; The name of the installer
Name "Brutal file manager"

; The file to write
OutFile "bfm-1.2-installer.exe"

; The default installation directory
InstallDir "$PROGRAMFILES\Brutal file manager"

; Registry key to check for directory (so if you install again, it will 
; overwrite the old one automatically)
InstallDirRegKey HKLM "Software\BFM" "Install_Dir"

LicenseData "COPYING"

;--------------------------------

; Pages

Page license
Page components
Page directory
Page instfiles

UninstPage uninstConfirm
UninstPage instfiles

;--------------------------------

; The stuff to install
Section "BFM"

  SectionIn RO
  
  ; Set output path to the installation directory.
  SetOutPath $INSTDIR
  
  ; Put file there
  File "Bfm.jar"
  File "src\data\images\Bfm.ico"
  File "COPYING"
  File "ChangeLog"
  File "README"
  File "TODO"
  File "NEWS"

  Rename "$INSTDIR\COPYING" "$INSTDIR\COPYING.txt"
  Rename "$INSTDIR\ChangeLog" "$INSTDIR\ChangeLog.txt"
  Rename "$INSTDIR\README" "$INSTDIR\README.txt"
  Rename "$INSTDIR\TODO" "$INSTDIR\TODO.txt"
  Rename "$INSTDIR\NEWS" "$INSTDIR\NEWS.txt"

  ; Write the installation path into the registry
  WriteRegStr HKLM SOFTWARE\bfm "Install_Dir" "$INSTDIR"
  
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\BFM" "DisplayName" "Brutal file manager"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\BFM" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\BFM" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\BFM" "NoRepair" 1
  WriteUninstaller "uninstall.exe"
  
SectionEnd

Section "Source code"
	SetOutPath $INSTDIR\src
	File src\*.java
	SetOutPath $INSTDIR\src\data
	File src\data\manifest
	SetOutPath $INSTDIR\src\data\images
	File src\data\images\*.*
  
SectionEnd

; Optional section (can be disabled by the user)
Section "Start Menu Shortcuts"

  CreateDirectory "$SMPROGRAMS\Brutal file manager"
  CreateShortCut "$SMPROGRAMS\Brutal file manager\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
  CreateShortCut "$SMPROGRAMS\Brutal file manager\Brutal file manager.lnk" "$INSTDIR\Bfm.jar" "" "$INSTDIR\Bfm.ico" 0
  CreateShortCut "$SMPROGRAMS\Brutal file manager\Brutal file manager (safemode).lnk" "$INSTDIR\Bfm.jar" "-s" "$INSTDIR\Bfm.ico" 0
  
SectionEnd

Section "Desktop Shortcut"

  CreateShortCut "$DESKTOP\Brutal file manager.lnk" "$INSTDIR\Bfm.jar" "" "$INSTDIR\Bfm.ico" 0
  
SectionEnd

Section "Quick Launch Shortcut"

  CreateShortCut "$QUICKLAUNCH\Brutal file manager.lnk" "$INSTDIR\Bfm.jar" "" "$INSTDIR\Bfm.ico" 0
  
SectionEnd

;--------------------------------

; Uninstaller

Section "Uninstall"
  
  ; Remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\BFM"
  DeleteRegKey HKLM SOFTWARE\BFM

  ; Remove files and uninstaller
  Delete $INSTDIR\Bfm.jar
  Delete $INSTDIR\Bfm.ico
  Delete $INSTDIR\COPYING.txt
  Delete $INSTDIR\ChangeLog.txt
  Delete $INSTDIR\NEWS.txt
  Delete $INSTDIR\README.txt
  Delete $INSTDIR\TODO.txt
  Delete $INSTDIR\uninstall.exe

  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\Brutal file manager\*.*"
  Delete "$DESKTOP\Brutal file manager.lnk"
  Delete "$QUICKLAUNCH\Brutal file manager.lnk"

  ; Remove directories used
  RMDir "$SMPROGRAMS\Brutal file manager"
  RMDir /r $INSTDIR\src
  RMDir "$INSTDIR"

SectionEnd
