/*
    BFM, the Brutal File Manager. A 3D fps filemanager
    Copyright (C) 2003  Henrik Johansson and Daniel Forchheimer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class DroppedDynamite extends RoomObject {
	private Room room;
	private float time, expand= .3f, damage=.1f;
	private int explotionFrames= 20;
	private Vector3f position;

	public DroppedDynamite( TransformGroup trans, Room room, Transform3D transform, Vector3f position ) {
		this.room= room;
		this.position= position;
		setCapability(BranchGroup.ALLOW_DETACH);
		trans.setTransform(transform);
		addChild( trans );
	}

	public void run( float delay ) {
		/* wait or explode... */
		time+= delay;
		if( time>3 ) {
			Explotion explotion= new Explotion( explotionFrames, expand, room, position );
			room.addChild( explotion );

			finished= true;
		}
	}

	public void finish() { run( 42f ); }
}
