/*
    BFM, the Brutal File Manager. A 3D fps filemanager
    Copyright (C) 2003  Henrik Johansson and Daniel Forchheimer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class Explotion extends RoomObject {
	private int explotionTime= 200;
	private Room room;
	private Vector3f position;
	private float expand, time= 0, duration= .2f;
	private int explotionFrames;
	private TransformGroup tg= new TransformGroup();

	public Explotion( int explotionFrames, float expand, Room room, Vector3f position ) {
		this.room= room;
		this.position= position;
		this.expand= expand;
		this.explotionFrames= explotionFrames;
		setCapability(BranchGroup.ALLOW_DETACH);
		Appearance fireAppearance= new Appearance();
		Color3f fireColor= new Color3f( 1,0,0 );
		Material fire= new Material( fireColor, fireColor, fireColor, fireColor, 128 );
		TransparencyAttributes ta= new TransparencyAttributes(TransparencyAttributes.BLENDED,.8f);
		fireAppearance.setTransparencyAttributes(ta);
		fireAppearance.setMaterial(fire);
		for( int i=0; i<explotionFrames; i++ ) {
			tg.addChild( new Sphere( (expand*explotionFrames)/2+(expand*i)/2, fireAppearance ));
		}
		Transform3D t3d= new Transform3D();
		t3d.setTranslation( position );
		tg.setTransform(t3d);
		addChild(tg);
		kill();
	}

	public void run( float delay ) {
		time+= delay;
		if( time>duration ) finished= true;
	}

	public void kill() {
		/*  ...hit files... */
		float explotionRadius= explotionFrames*expand;
		for( int i=0; i<room.numChildren(); i++ ) {
			try {
				Vector3f v= new Vector3f();
				v.sub( position, ((FileObject)(room.getChild(i))).getFilePosition());
				float distance= (float)Math.sqrt( v.x*v.x+v.z*v.z );
				if( distance-room.getFileRadius()<explotionRadius ) {
					((FileObject)(room.getChild(i))).hit( Math.abs(explotionRadius/(distance-room.getFileRadius() )));
				}
			} catch( Exception e ) {}
		}
		/*  ...and player(s) :) */
		Vector3f v= new Vector3f();
		v.sub( position, room.getBfm().getPlayer().getPositionVector() );
		float distance= (float)Math.sqrt( v.x*v.x+v.z*v.z );
		if( distance<explotionRadius ) room.getBfm().getPlayer().setAlive( false );
	}

	public void finish() {}

}
