/*
    BFM, the Brutal File Manager. A 3D fps filemanager
    Copyright (C) 2003  Henrik Johansson and Daniel Forchheimer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import java.awt.*;
import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import java.io.*;
import com.sun.j3d.utils.image.*;
import java.net.URL;

public class FSDocument extends TransformGroup {

	public FSDocument(Appearance app,float height, float width ) {
		float uh = 0.1f;
		String textureName = "data/images/textureDocument.png";

     // mix the texture and the material colour
    TextureAttributes ta = new TextureAttributes();
    ta.setTextureMode(TextureAttributes.DECAL);
    app.setTextureAttributes(ta);

    // load and set the texture
		URL url=this.getClass().getResource(textureName);
    TextureLoader loader = new TextureLoader(url, null);
    Texture2D texture = (Texture2D) loader.getTexture();
    app.setTexture(texture);      // set the texture

		
		addChild(new Box(width/2,height/2-uh,.2f,Primitive.GENERATE_TEXTURE_COORDS|Primitive.GENERATE_NORMALS,app));
		
		/*corner*/
		Transform3D rot = new Transform3D();
		rot.rotZ(0.785f);
		TransformGroup rotTG = new TransformGroup(rot);
		
		Transform3D moveT3D= new Transform3D();
		moveT3D.setTranslation(new Vector3f(-width/2+0.14f,height/2f-uh,0f));
		TransformGroup moveTrans= new TransformGroup(moveT3D);

		rotTG.addChild(new Box(0.1f,uh,.2f,app));
		moveTrans.addChild(rotTG);
		addChild(moveTrans);
		
		/*upper box*/
		moveT3D= new Transform3D();
		moveT3D.setTranslation(new Vector3f(0.07f,height/2f-uh+0.02f,0f));
		moveTrans= new TransformGroup(moveT3D);
		moveTrans.addChild(new Box(width/2-0.07f,uh+0.02f,.2f,app));
		addChild(moveTrans);

	}
}
