/*
    BFM, the Brutal File Manager. A 3D fps filemanager
    Copyright (C) 2003  Henrik Johansson and Daniel Forchheimer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import java.awt.*;
import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import java.io.*;
import com.sun.j3d.utils.image.*;
import javax.imageio.*;
import java.awt.image.*;
import java.awt.geom.AffineTransform;
import java.awt.image.AffineTransformOp;
import java.net.URL;
import java.util.ArrayList;

public class FSPicture extends TransformGroup {
	Shape3D sh;
	QuadArray qa;
	Appearance fileApp;			
	File file;
	float height;
	
	public FSPicture(Appearance app,float height, float width,File file) {
		String textureFileName = "data/images/imageError.png";
		this.file = file;
		this.height = height; /* lagra height i this.height*/
													/* henrik vill ha mer kommentarer*/
													/* den hr raden gr ingenting */
		                      /* henrik: "det r uppfattat!" */

	  fileApp = new Appearance();
		//fileApp.setCapability(Appearance.ALLOW_TEXTURE_WRITE);
		double thumbnailResolution=200;	 
		// mix the texture and the material colour
		TextureAttributes ta = new TextureAttributes();
		ta.setTextureMode(TextureAttributes.REPLACE|TextureAttributes.FASTEST);
		fileApp.setTextureAttributes(ta);

		this.qa = new QuadArray(8,QuadArray.COORDINATES| QuadArray.TEXTURE_COORDINATE_3);
		qa.setCapability(QuadArray.ALLOW_COORDINATE_WRITE);
		qa.setCapability(QuadArray.ALLOW_TEXCOORD_WRITE );
		
		sh = new Shape3D(qa,fileApp);
		sh.setCapability(Shape3D.ALLOW_APPEARANCE_WRITE);

		ThumbnailTextureLoader.add(this);

		resize(1,1);
		
		addChild(sh);

	}

	public void resize(float width, float height) {
					
	 	qa.setCoordinate(0,     new Point3f(-width/2 ,-height/2, 0));
	 	qa.setCoordinate(1,     new Point3f(-width/2 ,height/2, 0));
	 	qa.setCoordinate(2,     new Point3f(width/2 ,height/2,  0));
	 	qa.setCoordinate(3,     new Point3f(width/2 ,-height/2,  0));
	 	qa.setCoordinate(7,     new Point3f(-width/2 ,-height/2, 0));
	 	qa.setCoordinate(6,     new Point3f(-width/2 ,height/2, 0));
	 	qa.setCoordinate(5,     new Point3f(width/2 ,height/2,  0));
	 	qa.setCoordinate(4,     new Point3f(width/2 ,-height/2,  0));

	 	qa.setTextureCoordinate(0,3,     new TexCoord3f(0 ,0, 0));
	 	qa.setTextureCoordinate(0,2,     new TexCoord3f(0 ,1, 0));
	 	qa.setTextureCoordinate(0,1,     new TexCoord3f(1 ,1,  0));
	 	qa.setTextureCoordinate(0,0,     new TexCoord3f(1 ,0,  0));
	 	qa.setTextureCoordinate(0,7,     new TexCoord3f(0 ,0, 0));
	 	qa.setTextureCoordinate(0,6,     new TexCoord3f(0 ,1, 0));
	 	qa.setTextureCoordinate(0,5,     new TexCoord3f(1 ,1,  0));
	 	qa.setTextureCoordinate(0,4,     new TexCoord3f(1 ,0,  0));
		
	}
	
	public void setAppearance(Appearance app) {
		this.sh.setAppearance(app);
	}
	
	public float getHeight() {
		return height;
	}
	
	public Appearance getAppearance() {
		return this.fileApp;
	}
	public File getFile() {
		return this.file;
	}
	
	public static BufferedImage scale(BufferedImage image, double factor) {
		AffineTransformOp op = new AffineTransformOp(
    AffineTransform.getScaleInstance(
                  factor, factor), AffineTransformOp.TYPE_NEAREST_NEIGHBOR);
          return op.filter(image, null);
	}

	static class ThumbnailTextureLoader implements Runnable {
		static ArrayList todo = new ArrayList();
		static Thread t;
		static Appearance loadingAppearance;
		
		static ThumbnailTextureLoader INSTANCE = new ThumbnailTextureLoader();
		
		static double thumbnailResolution=200;	 
	
		static void add(FSPicture fsp) {
			todo.add(fsp);
			if(loadingAppearance == null) {
				createLoadingAppearance();
			}
			fsp.setAppearance(loadingAppearance);
			if(t==null || !t.isAlive()) {
				t = new Thread(INSTANCE);
				t.start();
			}
		}
		
		static void createLoadingAppearance() {
			loadingAppearance = new Appearance();
		  // load and set the texture
      URL url = ThumbnailTextureLoader.class.getResource("data/images/imageLoading.png");
	    TextureLoader loader = new TextureLoader(url, null);
  	  Texture2D texture = (Texture2D) loader.getTexture();
  	  loadingAppearance.setTexture(texture);      // set the texture
		}

		
		public void run() {
		String errorTextureFileName = "data/images/imageError.png";
		
			while(todo.size()>0) {
				FSPicture fsp = (FSPicture)(todo.get(0));
				File file = fsp.getFile();
				Appearance app = new Appearance();
				
				BufferedImage bfimg=null;
				try{
					bfimg = ImageIO.read(file);
				} catch (IOException e) {}
				
				if(bfimg==null) {
					System.out.println("error loading thumbnail: " + file.getName());
					try{
						URL imageError = getClass().getResource(errorTextureFileName);
						bfimg = ImageIO.read(imageError);
					} catch(IOException ie) {}
				} else {
					System.out.println("loading thumbnail: " + file.getName());
				}
				float height = fsp.getHeight();
				float width = height*bfimg.getWidth()/bfimg.getHeight();
				fsp.resize(width,height);
				
				try{
					BufferedImage scbfimg = scale(bfimg,thumbnailResolution/bfimg.getHeight());
	
					TextureLoader loader = new TextureLoader(scbfimg);
		//TextureLoader loader = new TextureLoader(scimg,null);
  //TextureLoader loader = new TextureLoader(file.getAbsolutePath()/*, TextureLoader.BY_REFERENCE|TextureLoader.Y_UP*/,null);
  			  Texture2D texture = (Texture2D) loader.getTexture();
  			  app.setTexture(texture);      // set the texture
		    } catch(Exception e) {
						System.out.println("apan");
				}
				
				fsp.setAppearance(app);
				
				todo.remove(0);
				try {
				t.sleep(1000);
				} catch (InterruptedException ie) {}
			}
		}
	}
}

