/*
    BFM, the Brutal File Manager. A 3D fps filemanager
    Copyright (C) 2003  Henrik Johansson and Daniel Forchheimer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import javax.vecmath.*;

public abstract class Pattern {
	float minRadius=1000;
	
	public Pattern() {}
	abstract Vector3f getPosition(int n);
	public float getMinRadius() {
		return minRadius;
	}
	/* setMinRadius is called with several arguments so that different
		 patterns can react to different criteria */
	abstract void setMinRadius(int numDir,int numFiles,float lastRadius);
}
