/*
    BFM, the Brutal File Manager. A 3D fps filemanager
    Copyright (C) 2003  Henrik Johansson and Daniel Forchheimer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import javax.vecmath.*;

public class PatternCircle extends Pattern {
	private float fileRadius;

	public PatternCircle( float fileRadius ) {
		this.fileRadius= fileRadius;
	}	

	public Vector3f getPosition(int n) {
		int i,posInCircle=0;
		int spacesInCircle=1;
		float r=0;
		float theta;
		for(i=0;i<n;i++) {
			if(spacesInCircle==posInCircle+1) {
				r+=fileRadius*4;
				spacesInCircle= (int)(r*2*Math.PI/(fileRadius*3));
				posInCircle=0;
			} else {
			posInCircle++;
			}
		}
		theta = (float)(2*Math.PI/spacesInCircle * posInCircle);
		minRadius=r;
		return new Vector3f((float)Math.cos(theta)*r,0f,(float)Math.sin(theta)*r);
	}
	public void setMinRadius(int numDirs,int numFiles,float radius) {
		int i,posInCircle=0;
		int spacesInCircle=1;
		float r=0;
		float theta;
		for(i=0;i<numFiles;i++) {
			if(spacesInCircle==posInCircle+1) {
				r+=fileRadius*4;
				spacesInCircle= (int)(r*2*Math.PI/(fileRadius*3));
				posInCircle=0;
			} else {
			posInCircle++;
			}
		}
		minRadius=r+fileRadius*4;
	}
}
